#include "stdafx.h"
#include "graham's scan.h"

void FirstPoint(std::vector <Point> &PointLocate)
{
	for (unsigned int i = 1; i < PointLocate.size(); i++)
	{
		if (PointLocate[0].y < PointLocate[i].y)
		{
			std::swap(PointLocate[0], PointLocate[i]);
		}
		else if (PointLocate[0].y == PointLocate[i].y)
		{
			if (PointLocate[0].x > PointLocate[i].x)
			{
				std::swap(PointLocate[0], PointLocate[i]);
			}
		}
	}
}

bool Comp(Point &angle, Point &angle2)
{
	return angle.angle < angle2.angle;
}

void PointSort(std::vector<Point> &PointLocate, std::stack<Point> &ConvexPoint)
{
	int nSize = PointLocate.size();
	sort(PointLocate.begin(), PointLocate.end(), Comp);

	ConvexPoint.push(PointLocate[0]);
	ConvexPoint.push(PointLocate[1]);
	ConvexPoint.push(PointLocate[2]);
}

void PointAngle(std::vector<Point> &PointLocate)
{
	const double PI = 3.141592;
	float cx, cy, angle;

	for (unsigned int i = 1; i < PointLocate.size(); i++)
	{
		cx = (float)PointLocate[i].x - (float)PointLocate[0].x;
		cy = (float)PointLocate[i].y - (float)PointLocate[0].y;

		angle = atan2(cy, cx);
		angle = angle * 180 / (float)PI;
		PointLocate[i].angle = fabs(angle);
	}
	PointLocate[0].angle = 0;
}
void PointSearch(std::vector<Point> &PointLocate, std::stack<Point> &ConvexPoint)
{
	Point P1 = PointLocate[1];
	Point P2 = PointLocate[2];

	for (unsigned int i = 3; i < PointLocate.size(); i++)
	{
		while (ccw(P1, P2, PointLocate[i]) <= 0 && PointLocate[i].angle>0)
		{
				ConvexPoint.pop();

				P2 = ConvexPoint.top();
				ConvexPoint.pop();
				P1 = ConvexPoint.top();
				ConvexPoint.push(P2);
		}
		if (PointLocate[i].angle!=0)
		{
			ConvexPoint.push(PointLocate[i]);
		}
				
		P2 = ConvexPoint.top();
		ConvexPoint.pop();
		P1 = ConvexPoint.top();
		ConvexPoint.push(P2);
	}
}

int ccw(Point p1, Point p2, Point p3)
{
	return (p2.x - p1.x)*((1000-p3.y) - (1000-p1.y)) - ((1000-p2.y) - (1000-p1.y))*(p3.x - p1.x);
}